Subject: Re: bug#31169: 26.1; Emacs 26.1 RC1 (gtk) display issues over SSH/X11 with xming/vcxsrv

From: charlie hemlock <[email-masked]>
Date: Wed, 18 Apr 2018 20:58:10 -0400

> That's the fringe.  And that's already bad: why isn't it being
> displayed?  The fringe on the left displays correctly.

Ah ok.  I suspect this could be a vcxsrv issue. As if I resize the emacs
window it can go away. See 2 attachments build with lucid.
Only change is resizing window.

> Do you see anything in the *Messages* buffer that could hint on the
problem?

No messages. Note I can't see it in gtk builds - but I can save the
messages buffer to file and confirm its just the default message.
"For information about GNU Emacs and the GNU system, type C-h C-a."

> Maybe the Motif build bit-rotted.  Is it possible for you to try
> building with Lucid instead? If the Lucid build shows the same
> problem when run locally, I think the local display problems need to
> be investigated first, but I wonder how come no one else sees these
> display problems, they are pretty apparent and cannot be missed.

See attachments (remote display emacs lucid).  I don't believe I have any
local display issues.

Sorry for the repeated links for the gtk menu bugs (long day), they should
have been:
- https://bugs.launchpad.net/ubuntu/+source/gtk+3.0/+bug/1700319
- https://bugs.launchpad.net/ubuntu/+source/gtk+3.0/+bug/992464

> This bug says the problem is fixed in GTK+ 3.22.25.  Can you try that
version of GTK+?
See table below.

> Those are for Emacs 23, 24, and 25, whereas you said Emacs 25 workedf or
you.  So how can those be the same problems?  And if they are the
> same problem, clearly the solution should be in GTK+, not in Emacs,right?

So Emacs 25.3 gtk3 displayed via *xming* also core dumps.  Like I said the
# of combinations is growing.
Also feels like there we're dealing with more than one bug here.
I'd feel a lot better if someone else could replicate.

An attempt to recap (xming 6.9.0.31, VcXsrv  1.19.6.3)

CentOS7, gtk: 2.24.31,  gtk3: 3.22.10
| emacs      | Xming     | VcXsrv                 |
+------------+-----------+------------------------+
| 25.3  gtk2 | ok        | ok                     |
| 25.3  gtk3 | core dump | display ok, menus bad  |
| 26.1  gtk2 | ok        | bad, but menus ok      |
| 26.1  gtk3 | core dump | bad, menus bad         |

OpenSUSE Leap 42.3 , gtk2: 2.24.31,  gtk3: 3.22.10
| emacs      | Xming     | VcXsrv             |
+------------+-----------+--------------------+
| 25.3  gtk2 | ok        | ok                 |
| 25.3  gtk3 | core dump | ok                 |
| 26.1  gtk2 | ok        | bad, but menus ok  |
| 26.1  gtk3 | core dump | bad, but menus ok  |

OpenSUSE Tumbleweed, gtk2: 2.24.32,  gtk3: 3.22.29
| emacs      | Xming     | VcXsrv
+------------+-----------+---------------------------+
| 25.3  gtk2 | ok        | ok                        |
| 25.3  gtk3 | ok        | ok                        |
| 26.1  gtk2 | ok        | sometimes bad?!, menus ok |
| 26.1  gtk3 | ok        | bad, but menus ok         |

core dump references https://bugzilla.gnome.org/show_bug.cgi?id=85715
bad = bad display of minibuffer and main buffer.
menu ok = refers to clicking File Menu and buttons.

(tumbleweed and centos are VMs)

Thanks,
CH

On Wed, Apr 18, 2018 at 9:20 AM, Eli Zaretskii <[email-masked]> wrote:

> > From: charlie hemlock <[email-masked]>
> > Date: Tue, 17 Apr 2018 20:30:33 -0400
> > Cc: [email-masked]
> >
> > > The Motif frame looks better, but still not entirely normal: what's
> that empty space to the right of the
> > window? Is that similar  to what you see locally on the GNU/Linux box?
> >
> > That empty narrow space looks similar as locally launched Emacs. That
> narrow area is where line wrap
> > indicators show up.
>
> That's the fringe.  And that's already bad: why isn't it being
> displayed?  The fringe on the left displays correctly.  Do you see
> anything in the *Messages* buffer that could hint on the problem?
>
> Maybe the Motif build bit-rotted.  Is it possible for you to try
> building with Lucid instead?  If the Lucid build shows the same
> problem when run locally, I think the local display problems need to
> be investigated first, but I wonder how come no one else sees these
> display problems, they are pretty apparent and cannot be missed.
>
> > I also clicked the "File" button on menu bar, and got several errors
> below, and the File Menu did not display:
> > However, Clicking the Open File icon did open the file browser .
> > Related to this menu issue:
> >  - https://bugs.launchpad.net/ubuntu/+source/gtk+3.0/+bug/1700319
> >  - https://bugs.launchpad.net/ubuntu/+source/gtk+3.0/+bug/1700319
> >  - Can't say if these are related to the original display issues
> discussed here or entire separate issue
>
> This bug says the problem is fixed in GTK+ 3.22.25.  Can you try that
> version of GTK+?
>
> > % ~/release/emacs_26.1/bin/emacs -Q
> >
> > (emacs:3612): Gtk-CRITICAL **: gtk_widget_get_preferred_height_for_width:
> assertion 'width >= 0' failed
> >
> > [[removed several repeats]]
> >
> > (emacs:3612): Gtk-CRITICAL **: gtk_widget_get_preferred_height_for_width:
> assertion 'width >= 0' failed
> > *** BUG ***
> > In pixman_region32_init_rect: Invalid rectangle passed
> > Set a breakpoint on '_pixman_log_error' to debug
> >
> > *** BUG ***
> > In pixman_region32_init_rect: Invalid rectangle passed
> > Set a breakpoint on '_pixman_log_error' to debug
> >
> > (emacs:3612): Gtk-WARNING **: Negative content width -7 (allocation 1,
> extents 4x4) while allocating gadget
> > (node arrow, owner GtkMenu)
> >
> > (emacs:3612): Gtk-WARNING **: Negative content width -7 (allocation 1,
> extents 4x4) while allocating gadget
> > (node arrow, owner GtkMenu)
> > *** BUG ***
> > In pixman_region32_init_rect: Invalid rectangle passed
> > Set a breakpoint on '_pixman_log_error' to debug
> >
> > (emacs:3612): Gtk-WARNING **: Negative content width -11 (allocation 1,
> extents 6x6) while allocating
> > gadget (node menuitem, owner GtkMenuItem)
> >
> > (emacs:3612): Gtk-WARNING **: Negative content height -7 (allocation 1,
> extents 4x4) while allocating gadget
> > (node menuitem, owner GtkMenuItem)
>
> And Emacs 25, which works for you in the same setup, uses the same
> version of GTK+ as the 26.1RC1 build?
>
> > The emacs gui launches and appears ok, but core dumps as soon as I
> attempt anything else.
> > % ~/release/emacs_26.1/bin/emacs -Q
> > # click anywhere
> > X protocol error: BadRequest (invalid request code or no such operation)
> on protocol request 130
> > When compiled with GTK, Emacs cannot recover from X disconnects.
> > This is a GTK bug: https://bugzilla.gnome.org/show_bug.cgi?id=85715
> > For details, see etc/PROBLEMS.
> > Fatal error 6: Aborted
> >
> > But I did include that bug link in original post.   I can't say if these
> are closely or distantly or not related.
>
> Those are for Emacs 23, 24, and 25, whereas you said Emacs 25 worked
> for you.  So how can those be the same problems?  And if they are the
> same problem, clearly the solution should be in GTK+, not in Emacs,
> right?
>